% sistema 2 equazioni stiff
testfunction=1;
h=0.001;

M=2;
hmeth1=zeros(M+1,1);
hmeth2=zeros(M+1,1);
herr1=zeros(M,1);
herr2=zeros(M,1);
hmethp=zeros(M+1,1);
hstep=zeros(M,1);
labmeth=cell(M+1,1);
laberr=cell(M,1);

col='brgcmy';

switch testfunction
    case 1
        funz='[998*y(1)+1998*y(2); -999*y(1)-1999*y(2)]';
        f=inline(funz,'t','y');
        solution=inline('[2*exp(-t)-exp(-1000*t), -exp(-t)+exp(-1000*t)]');
        y0=[1 0];
        DT=[0 1];
end

methods=0;

% ode23
methlab='ode23';
fprintf('%s - ',methlab)
methods=methods+1;
labmeth{1}='True';
labmeth{methods+1}=methlab;
laberr{methods}=methlab;
tic
[t y]=ode23(f,DT,y0);
tim=toc;
fprintf('Steps: %i - ',length(t))
figure(1)
set(gcf,'Name','Soluzioni')
clf
ytrue=solution(t);
subplot(2,2,1)
hmeth1(1)=plot(t,ytrue(:,1),'-k','LineWidth',2);
hold on
subplot(2,2,3)
hmeth2(1)=plot(t,ytrue(:,2),'-k','LineWidth',2);
hold on
subplot(2,2,2)
herr1(methods)=plot(t,y(:,1)-ytrue(:,1),col(methods),'LineWidth',2);
hold on
subplot(2,2,4)
herr2(methods)=plot(t,y(:,2)-ytrue(:,2),col(methods),'LineWidth',2);
hold on
maxerr=max(abs(y-ytrue));
fprintf(' L-infty error: %f %f --',maxerr)
subplot(2,2,1)
hmeth1(methods+1)=plot(t,y(:,1),['*' col(methods)]);
subplot(2,2,3)
hmeth2(methods+1)=plot(t,y(:,2),['*' col(methods)]);
fprintf(' CPU time: %f\n',tim)
figure(2)
clf
set(gcf,'Name','Phase plot')
hmethp(1)=plot(ytrue(:,1),ytrue(:,2),'k');
hold on
hmethp(methods+1)=plot(y(:,1),y(:,2),col(methods));
figure(3)
clf
set(gcf,'Name','Step plot')
hstep(methods)=plot(t(1:end-1),diff(t),col(methods));
hold on

% ode23s
methlab='ode23s';
fprintf('%s - ',methlab)
methods=methods+1;
labmeth{methods+1}=methlab;
laberr{methods}=methlab;
tic
[t y]=ode23s(f,DT,y0);
tim=toc;
fprintf('Steps: %i - ',length(t))
figure(1)
ytrue=solution(t);
subplot(2,2,2)
herr1(methods)=plot(t,y(:,1)-ytrue(:,1),col(methods),'LineWidth',2);
subplot(2,2,4)
herr2(methods)=plot(t,y(:,2)-ytrue(:,2),col(methods),'LineWidth',2);
maxerr=max(abs(y-ytrue));
fprintf(' L-infty error: %f %f --',maxerr)
subplot(2,2,1)
hmeth1(methods+1)=plot(t,y(:,1),['*' col(methods)]);
subplot(2,2,3)
hmeth2(methods+1)=plot(t,y(:,2),['*' col(methods)]);
fprintf(' CPU time: %f\n',tim)
figure(2)
hmethp(methods+1)=plot(y(:,1),y(:,2),col(methods));
figure(3)
hstep(methods)=plot(t(1:end-1),diff(t),col(methods));
hold on

% Eulero
methlab='Eulero';
fprintf('%s - ',methlab)
methods=methods+1;
labmeth{methods+1}=methlab;
laberr{methods}=methlab;
tic
[t y]=myeuler_2d(f,DT,y0,h);
tim=toc;
fprintf('Steps: %i - ',length(t))
figure(1)
ytrue=solution(t);
subplot(2,2,2)
herr1(methods)=plot(t,y(:,1)-ytrue(:,1),col(methods),'LineWidth',2);
subplot(2,2,4)
herr2(methods)=plot(t,y(:,2)-ytrue(:,2),col(methods),'LineWidth',2);
maxerr=max(abs(y-ytrue));
fprintf(' L-infty error: %f %f --',maxerr)
subplot(2,2,1)
hmeth1(methods+1)=plot(t,y(:,1),['*' col(methods)]);
subplot(2,2,3)
hmeth2(methods+1)=plot(t,y(:,2),['*' col(methods)]);
fprintf(' CPU time: %f\n',tim)
figure(2)
hmethp(methods+1)=plot(y(:,1),y(:,2),col(methods));
figure(3)
hstep(methods)=plot(t(1:end-1),diff(t),col(methods));
hold on

% End methods

figure(1)
subplot(2,2,1)
xlabel('t'), ylabel('y_1')
title('Time history - solution')
legend(hmeth1,labmeth,'Location','Best')
subplot(2,2,3)
xlabel('t'), ylabel('y_2')
title('Time history - solution')
legend(hmeth2,labmeth,'Location','Best')
subplot(2,2,2)
xlabel('t'), ylabel('y_1')
title('Time history - L_\infty error')
legend(herr1,laberr,'Location','Best')
subplot(2,2,4)
xlabel('t'), ylabel('y_2')
title('Time history - L_\infty error')
legend(herr2,laberr,'Location','Best')

figure(2)
xlabel('y_1'), ylabel('y_2'), title('Phase plane plot')
legend(hmethp,labmeth,'Location','Best')

figure(3)
xlabel('t'), ylabel('\Delta t'), title('Timestep')
legend(hstep,laberr,'Location','Best')

























































